MWAWGraphicListener Class Reference documentation

Public Member Functions | Protected Member Functions | Protected Attributes | Private Member Functions | List of all members
MWAWGraphicListener Class Reference

This class contains the code needed to create Graphic document. More...

`#include <MWAWGraphicListener.hxx>`

Inheritance diagram for MWAWGraphicListener:

## Public Member Functions
| MWAWGraphicListener (MWAWParserState &parserState, std::vector< MWAWPageSpan > const &pageList, librevenge::RVNGDrawingInterface *documentInterface)
| constructor More...
| MWAWGraphicListener (MWAWParserState &parserState, MWAWBox2f const &box, librevenge::RVNGDrawingInterface *documentInterface)
| simplified constructor (can be used for a embedded graphic with one page). More...
virtual | ~MWAWGraphicListener ()
| destructor More...
Type | getType () const
| returns the listener type More...
void | setDocumentMetaData (librevenge::RVNGPropertyList const &metadata)
| sets the documents metadata More...
void | setDocumentLanguage (std::string const &locale)
| sets the documents language More...
void | startDocument ()
| starts a new document More...
void | endDocument (bool delayed=true)
| ends the actual document More...
bool | canWriteText () const
| returns true if a text zone is opened More...
bool | isDocumentStarted () const
| returns true if a document is opened More...
void | handleSubDocument (MWAWVec2f const &orig, MWAWSubDocumentPtr subDocument, libmwaw::SubDocumentType subDocumentType)
| function called to add a subdocument and modify the origin More...
void | handleSubDocument (MWAWSubDocumentPtr subDocument, libmwaw::SubDocumentType subDocumentType)
| function called to add a subdocument More...
bool | isSubDocumentOpened (libmwaw::SubDocumentType &subdocType) const
| returns try if a subdocument is open More...
bool | openFrame (MWAWPosition const &pos, MWAWGraphicStyle const &style=MWAWGraphicStyle::emptyStyle())
| store the position and the style (which will be needed further to insert a textbox or a table with openTable) More...
void | closeFrame ()
| close a frame More...
bool | openGroup (MWAWPosition const &pos)
| open a group More...
void | closeGroup ()
| close a group More...
bool | openLayer (librevenge::RVNGString const &name)
| open a layer More...
void | closeLayer ()
| close a layer More...
bool | openMasterPage (MWAWPageSpan &masterPage)
| opens a master page More...
void | closeMasterPage ()
| close a master page More...
bool | isPageSpanOpened () const
| returns true if a page is opened More...
MWAWPageSpan const & | getPageSpan ()
| returns the current page span More...
bool | insertHeader (MWAWSubDocumentPtr subDocument, librevenge::RVNGPropertyList const &extras)
| insert a header More...
bool | insertFooter (MWAWSubDocumentPtr subDocument, librevenge::RVNGPropertyList const &extras)
| insert a footer More...
bool | isHeaderFooterOpened () const
| returns true if the header/footer is open More...
void | insertChar (uint8_t character)
| adds a basic character, .. More...
void | insertCharacter (unsigned char c)
| insert a character using the font converter to find the utf8 character More...
int | insertCharacter (unsigned char c, MWAWInputStreamPtr &input, long endPos=-1)
| insert a character using the font converter to find the utf8 character and if needed, input to read extra character. More...
void | insertUnicode (uint32_t character)
| adds an unicode character. More...
void | insertUnicodeString (librevenge::RVNGString const &str)
| adds a unicode string More...
void | insertTab ()
| adds a tab More...
void | insertEOL (bool softBreak=false)
| adds an end of line ( by default an hard one) More...
void | setFont (MWAWFont const &font)
| sets the font More...
MWAWFont const & | getFont () const
| returns the actual font More...
bool | isParagraphOpened () const
| returns true if a paragraph or a list is opened More...
void | setParagraph (MWAWParagraph const &paragraph)
| sets the paragraph More...
MWAWParagraph const & | getParagraph () const
| returns the actual paragraph More...
void | insertField (MWAWField const &field)
| adds a field type More...
void | openLink (MWAWLink const &link)
| open a link More...
void | closeLink ()
| close a link More...
void | insertPicture (MWAWPosition const &pos, MWAWEmbeddedObject const &picture, MWAWGraphicStyle const &style=MWAWGraphicStyle::emptyStyle())
| adds a picture with potential various representationin given position More...
void | insertShape (MWAWPosition const &pos, MWAWGraphicShape const &shape, MWAWGraphicStyle const &style)
| adds a shape picture in given position More...
void | insertTextBox (MWAWPosition const &pos, MWAWSubDocumentPtr subDocument, MWAWGraphicStyle const &style)
| adds a textbox in given position More...
void | insertGroup (MWAWBox2f const &bdbox, MWAWSubDocumentPtr subDocument)
| adds a group: ie. More...
void | insertNote (MWAWNote const &note, MWAWSubDocumentPtr &subDocument)
| insert a note More...
void | insertComment (MWAWSubDocumentPtr &subDocument)
| adds comment More...
void | insertTable (MWAWPosition const &pos, MWAWTable &table, MWAWGraphicStyle const &style=MWAWGraphicStyle::emptyStyle())
| adds a table in given position More...
void | openTable (MWAWTable const &table)
| open a table (using the last parameters of openFrame for the position ) More...
void | openTable (MWAWPosition const &pos, MWAWTable const &table, MWAWGraphicStyle const &style)
| open a table in a given position More...
void | closeTable ()
| closes this table More...
void | openTableRow (float h, librevenge::RVNGUnit unit, bool headerRow=false)
| open a row with given height ( if h < 0.0, set min-row-height = -h ) More...
void | closeTableRow ()
| closes this row More...
void | openTableCell (MWAWCell const &cell)
| open a cell More...
void | closeTableCell ()
| close a cell More...
void | addEmptyTableCell (MWAWVec2i const &pos, MWAWVec2i span=MWAWVec2i(1, 1))
| add empty cell More...
bool | canOpenSectionAddBreak () const
| returns true if we can add open a section, add page break, ... More...
bool | isSectionOpened () const
| returns true if a section is opened More...
MWAWSection const & | getSection () const
| returns the actual section More...
bool | openSection (MWAWSection const &section)
| open a section if possible More...
bool | closeSection ()
| close a section More...
void | insertBreak (BreakType breakType)
| inserts a break type: ColumBreak, PageBreak, .. More...
Public Member Functions inherited from MWAWListener
virtual | ~MWAWListener ()
| destructor More...
virtual void | insertTextBoxInShape (MWAWPosition const &pos, MWAWSubDocumentPtr subDocument, MWAWGraphicShape const &, MWAWGraphicStyle const &frameStyle=MWAWGraphicStyle::emptyStyle())
| adds a textbox in given position More...

## Protected Member Functions
void | _openPageSpan (bool sendHeaderFooters=true)
| does open a new page (low level) More...
void | _closePageSpan (bool masterPage=false)
| does close a page (low level) More...
void | _startSubDocument ()
void | _endSubDocument ()
void | _handleFrameParameters (librevenge::RVNGPropertyList &propList, MWAWPosition const &pos, MWAWGraphicStyle const &style)
| adds in propList the frame parameters. More...
void | _openParagraph ()
void | _closeParagraph ()
void | _resetParagraphState (const bool isListElement=false)
void | _openListElement ()
| open a list level More...
void | _closeListElement ()
| close a list level More...
void | _changeList ()
| update the list so that it corresponds to the actual level More...
int | _getListId () const
| low level: find a list id which corresponds to actual list and a change of level. More...
void | _openSpan ()
void | _closeSpan ()
void | _flushText ()
shared_ptr< MWAWGraphicListenerInternal::State > | _pushParsingState ()
| creates a new parsing state (copy of the actual state) More...
void | _popParsingState ()
| resets the previous parsing state More...

## Protected Attributes
shared_ptr< MWAWGraphicListenerInternal::GraphicState > | m_ds
| the actual global state More...
shared_ptr< MWAWGraphicListenerInternal::State > | m_ps
| the actual local parse state More...
std::vector< shared_ptr< MWAWGraphicListenerInternal::State > > | m_psStack
| stack of local state More...
MWAWParserState & | m_parserState
| the parser state More...
librevenge::RVNGDrawingInterface * | m_documentInterface
| the document interface More...

## Private Member Functions
| MWAWGraphicListener (const MWAWGraphicListener &)
MWAWGraphicListener & | operator= (const MWAWGraphicListener &)

## Additional Inherited Members
Public Types inherited from MWAWListener
enum | Type { Graphic, Presentation, Spreadsheet, Text }
| the listener type More...
enum | BreakType { PageBreak =0, SoftPageBreak, ColumnBreak }
| the different break type More...

## Detailed Description

This class contains the code needed to create Graphic document.

Note
  All units are specified in librevenge::RVNG_POINT

## Constructor & Destructor Documentation

## § MWAWGraphicListener() [1/3]

MWAWGraphicListener::MWAWGraphicListener | ( | MWAWParserState & | parserState,
|  | std::vector< MWAWPageSpan > const & | pageList,
|  | librevenge::RVNGDrawingInterface * | documentInterface
| ) |  |

constructor

## § MWAWGraphicListener() [2/3]

MWAWGraphicListener::MWAWGraphicListener | ( | MWAWParserState & | parserState,
|  | MWAWBox2f const & | box,
|  | librevenge::RVNGDrawingInterface * | documentInterface
| ) |  |

simplified constructor (can be used for a embedded graphic with one page).

Note
  the box coordinates must be given in point.

## § ~MWAWGraphicListener()

MWAWGraphicListener::~MWAWGraphicListener | ( |  | ) |
| virtual

destructor

## § MWAWGraphicListener() [3/3]

MWAWGraphicListener::MWAWGraphicListener | ( | const MWAWGraphicListener & |  | ) |
| private

## Member Function Documentation

## § _changeList()

void MWAWGraphicListener::_changeList | ( |  | ) |
| protected

update the list so that it corresponds to the actual level

Referenced by _closePageSpan(), _endSubDocument(), _openSpan(), and closeTableCell().

## § _closeListElement()

void MWAWGraphicListener::_closeListElement | ( |  | ) |
| protected

close a list level

Referenced by _closeParagraph().

## § _closePageSpan()

void MWAWGraphicListener::_closePageSpan | ( | bool | masterPage = `false` | ) |
| protected

does close a page (low level)

Referenced by endDocument(), insertBreak(), and openMasterPage().

## § _closeParagraph()

void MWAWGraphicListener::_closeParagraph | ( |  | ) |
| protected

Referenced by _changeList(), _closePageSpan(), _endSubDocument(), closeTableCell(), insertEOL(), and openTable().

## § _closeSpan()

void MWAWGraphicListener::_closeSpan | ( |  | ) |
| protected

Referenced by _closeListElement(), _closeParagraph(), and setFont().

## § _endSubDocument()

void MWAWGraphicListener::_endSubDocument | ( |  | ) |
| protected

Referenced by _closePageSpan(), closeGroup(), closeLayer(), closeTable(), handleSubDocument(), and insertTable().

## § _flushText()

void MWAWGraphicListener::_flushText | ( |  | ) |
| protected

Referenced by _closeSpan(), insertEOL(), insertField(), and insertTab().

## § _getListId()

int MWAWGraphicListener::_getListId | ( |  | ) | const
| protected

low level: find a list id which corresponds to actual list and a change of level.

Note
  called when the list id is not set

Referenced by _changeList().

## § _handleFrameParameters()

void MWAWGraphicListener::_handleFrameParameters | ( | librevenge::RVNGPropertyList & | propList,
|  | MWAWPosition const & | pos,
|  | MWAWGraphicStyle const & | style
| ) |  |
| protected

adds in propList the frame parameters.

Note
  if there is some gradient, first draw a rectangle to print the gradient and them update propList

Referenced by insertFooter(), insertHeader(), insertPicture(), insertTextBox(), openGroup(), and openTable().

## § _openListElement()

void MWAWGraphicListener::_openListElement | ( |  | ) |
| protected

open a list level

Referenced by _openSpan().

## § _openPageSpan()

void MWAWGraphicListener::_openPageSpan | ( | bool | sendHeaderFooters = `true` | ) |
| protected

does open a new page (low level)

Referenced by endDocument(), getPageSpan(), handleSubDocument(), insertBreak(), insertGroup(), insertPicture(), insertShape(), insertTextBox(), openFrame(), openGroup(), and openLayer().

## § _openParagraph()

void MWAWGraphicListener::_openParagraph | ( |  | ) |
| protected

Referenced by _openSpan(), insertComment(), and insertNote().

## § _openSpan()

void MWAWGraphicListener::_openSpan | ( |  | ) |
| protected

Referenced by insertChar(), insertEOL(), insertField(), insertTab(), insertUnicode(), insertUnicodeString(), and openLink().

## § _popParsingState()

void MWAWGraphicListener::_popParsingState | ( |  | ) |
| protected

resets the previous parsing state

Referenced by _closePageSpan(), closeGroup(), closeLayer(), closeLink(), closeTable(), handleSubDocument(), and insertTable().

## § _pushParsingState()

shared_ptr< MWAWGraphicListenerInternal::State > MWAWGraphicListener::_pushParsingState | ( |  | ) |
| protected

creates a new parsing state (copy of the actual state)

Returns
  the old one

Referenced by handleSubDocument(), insertTable(), openGroup(), openLayer(), openLink(), and openTable().

## § _resetParagraphState()

void MWAWGraphicListener::_resetParagraphState | ( | const bool | isListElement = `false` | ) |
| protected

Referenced by _openListElement(), and _openParagraph().

## § _startSubDocument()

void MWAWGraphicListener::_startSubDocument | ( |  | ) |
| protected

Referenced by handleSubDocument(), insertTable(), openGroup(), openLayer(), and openTable().

## § addEmptyTableCell()

void MWAWGraphicListener::addEmptyTableCell | ( | MWAWVec2i const & | pos,
|  | MWAWVec2i | span = `MWAWVec2i(1,1)`
| ) |  |
| virtual

add empty cell

Implements MWAWListener.

## § canOpenSectionAddBreak()

bool MWAWGraphicListener::canOpenSectionAddBreak | ( |  | ) | const
| inlinevirtual

returns true if we can add open a section, add page break, ...

Implements MWAWListener.

## § canWriteText()

bool MWAWGraphicListener::canWriteText | ( |  | ) | const
| virtual

returns true if a text zone is opened

Implements MWAWListener.

Referenced by insertComment(), and insertNote().

## § closeFrame()

void MWAWGraphicListener::closeFrame | ( |  | ) |
| virtual

close a frame

Implements MWAWListener.

Referenced by insertFooter(), insertHeader(), insertTable(), and insertTextBox().

## § closeGroup()

void MWAWGraphicListener::closeGroup | ( |  | ) |
| virtual

close a group

Implements MWAWListener.

## § closeLayer()

void MWAWGraphicListener::closeLayer | ( |  | ) |

close a layer

## § closeLink()

void MWAWGraphicListener::closeLink | ( |  | ) |
| virtual

close a link

Implements MWAWListener.

## § closeMasterPage()

void MWAWGraphicListener::closeMasterPage | ( |  | ) |
| inline

close a master page

## § closeSection()

bool MWAWGraphicListener::closeSection | ( |  | ) |
| inlinevirtual

close a section

Implements MWAWListener.

## § closeTable()

void MWAWGraphicListener::closeTable | ( |  | ) |
| virtual

closes this table

Implements MWAWListener.

Referenced by _closePageSpan(), and _endSubDocument().

## § closeTableCell()

void MWAWGraphicListener::closeTableCell | ( |  | ) |
| virtual

close a cell

Implements MWAWListener.

Referenced by addEmptyTableCell(), and openTableCell().

## § closeTableRow()

void MWAWGraphicListener::closeTableRow | ( |  | ) |
| virtual

closes this row

Implements MWAWListener.

## § endDocument()

void MWAWGraphicListener::endDocument | ( | bool | delayed = `true` | ) |
| virtual

ends the actual document

Implements MWAWListener.

Referenced by MWAWTextListener::insertShape(), MsWksGraph::send(), HanMacWrdKGraph::sendEmptyPicture(), HanMacWrdJGraph::sendEmptyPicture(), HanMacWrdKGraph::sendFrame(), HanMacWrdJGraph::sendFrame(), ClarisWksGraph::sendGroupChild(), and MarinerWrtGraph::sendRule().

## § getFont()

MWAWFont const & MWAWGraphicListener::getFont | ( |  | ) | const
| virtual

returns the actual font

Implements MWAWListener.

## § getPageSpan()

MWAWPageSpan const & MWAWGraphicListener::getPageSpan | ( |  | ) |
| virtual

returns the current page span

Note
  this forces the opening of a new page if no page is opened.

Implements MWAWListener.

Referenced by insertFooter().

## § getParagraph()

MWAWParagraph const & MWAWGraphicListener::getParagraph | ( |  | ) | const
| virtual

returns the actual paragraph

Implements MWAWListener.

## § getSection()

MWAWSection const & MWAWGraphicListener::getSection | ( |  | ) | const
| virtual

returns the actual section

Implements MWAWListener.

## § getType()

Type MWAWGraphicListener::getType | ( |  | ) | const
| inlinevirtual

returns the listener type

Implements MWAWListener.

## § handleSubDocument() [1/2]

void MWAWGraphicListener::handleSubDocument | ( | MWAWVec2f const & | orig,
|  | MWAWSubDocumentPtr | subDocument,
|  | libmwaw::SubDocumentType | subDocumentType
| ) |  |

function called to add a subdocument and modify the origin

Referenced by insertComment(), insertFooter(), insertGroup(), insertHeader(), insertNote(), and insertTextBox().

## § handleSubDocument() [2/2]

void MWAWGraphicListener::handleSubDocument | ( | MWAWSubDocumentPtr | subDocument,
|  | libmwaw::SubDocumentType | subDocumentType
| ) |  |
| inlinevirtual

function called to add a subdocument

Implements MWAWListener.

## § insertBreak()

void MWAWGraphicListener::insertBreak | ( | BreakType | breakType | ) |
| virtual

inserts a break type: ColumBreak, PageBreak, ..

Implements MWAWListener.

## § insertChar()

void MWAWGraphicListener::insertChar | ( | uint8_t | character | ) |
| virtual

adds a basic character, ..

Implements MWAWListener.

Referenced by insertCharacter(), insertComment(), and insertNote().

## § insertCharacter() [1/2]

void MWAWGraphicListener::insertCharacter | ( | unsigned char | c | ) |
| virtual

insert a character using the font converter to find the utf8 character

Implements MWAWListener.

## § insertCharacter() [2/2]

int MWAWGraphicListener::insertCharacter | ( | unsigned char | c,
|  | MWAWInputStreamPtr & | input,
|  | long | endPos = `-1`
| ) |  |
| virtual

insert a character using the font converter to find the utf8 character and if needed, input to read extra character.

Returns
  the number of extra character read

Implements MWAWListener.

## § insertComment()

void MWAWGraphicListener::insertComment | ( | MWAWSubDocumentPtr & | subDocument | ) |
| virtual

adds comment

Note
  as RVNGDrawingInterface does not accept comment, comment can only be inserted in a text zone (and are inserted between –)

Implements MWAWListener.

## § insertEOL()

void MWAWGraphicListener::insertEOL | ( | bool | softBreak = `false` | ) |
| virtual

adds an end of line ( by default an hard one)

Implements MWAWListener.

## § insertField()

void MWAWGraphicListener::insertField | ( | MWAWField const & | field | ) |
| virtual

adds a field type

Implements MWAWListener.

## § insertFooter()

bool MWAWGraphicListener::insertFooter | ( | MWAWSubDocumentPtr | subDocument,
|  | librevenge::RVNGPropertyList const & | extras
| ) |  |
| virtual

insert a footer

Implements MWAWListener.

## § insertGroup()

void MWAWGraphicListener::insertGroup | ( | MWAWBox2f const & | bdbox,
|  | MWAWSubDocumentPtr | subDocument
| ) |  |

adds a group: ie.

next insertion will be done relative to this bdbox[0] position

## § insertHeader()

bool MWAWGraphicListener::insertHeader | ( | MWAWSubDocumentPtr | subDocument,
|  | librevenge::RVNGPropertyList const & | extras
| ) |  |
| virtual

insert a header

Implements MWAWListener.

## § insertNote()

void MWAWGraphicListener::insertNote | ( | MWAWNote const & | note,
|  | MWAWSubDocumentPtr & | subDocument
| ) |  |
| virtual

insert a note

Note
  as RVNGDrawingInterface does not accept note, note can only be inserted in a text zone (and are inserted between –)

Implements MWAWListener.

## § insertPicture()

void MWAWGraphicListener::insertPicture | ( | MWAWPosition const & | pos,
|  | MWAWEmbeddedObject const & | picture,
|  | MWAWGraphicStyle const & | style = `MWAWGraphicStyle::emptyStyle()`
| ) |  |
| virtual

adds a picture with potential various representationin given position

Implements MWAWListener.

## § insertShape()

void MWAWGraphicListener::insertShape | ( | MWAWPosition const & | pos,
|  | MWAWGraphicShape const & | shape,
|  | MWAWGraphicStyle const & | style
| ) |  |
| virtual

adds a shape picture in given position

Implements MWAWListener.

Referenced by insertNote(), MWAWTextListener::insertShape(), HanMacWrdKGraph::sendEmptyPicture(), HanMacWrdJGraph::sendEmptyPicture(), and MarinerWrtGraph::sendRule().

## § insertTab()

void MWAWGraphicListener::insertTab | ( |  | ) |
| virtual

adds a tab

Implements MWAWListener.

## § insertTable()

void MWAWGraphicListener::insertTable | ( | MWAWPosition const & | pos,
|  | MWAWTable & | table,
|  | MWAWGraphicStyle const & | style = `MWAWGraphicStyle::emptyStyle()`
| ) |  |

adds a table in given position

Referenced by insertGroup().

## § insertTextBox()

void MWAWGraphicListener::insertTextBox | ( | MWAWPosition const & | pos,
|  | MWAWSubDocumentPtr | subDocument,
|  | MWAWGraphicStyle const & | style
| ) |  |
| virtual

adds a textbox in given position

Implements MWAWListener.

Referenced by insertPicture(), MsWksGraph::send(), HanMacWrdJGraph::sendFrame(), HanMacWrdKGraph::sendFrame(), and ClarisWksGraph::sendGroupChild().

## § insertUnicode()

void MWAWGraphicListener::insertUnicode | ( | uint32_t | character | ) |
| virtual

adds an unicode character.

By convention if character=0xfffd(undef), no character is added

Implements MWAWListener.

Referenced by insertChar(), insertCharacter(), insertComment(), and insertNote().

## § insertUnicodeString()

void MWAWGraphicListener::insertUnicodeString | ( | librevenge::RVNGString const & | str | ) |
| virtual

adds a unicode string

Implements MWAWListener.

Referenced by insertField().

## § isDocumentStarted()

bool MWAWGraphicListener::isDocumentStarted | ( |  | ) | const
| virtual

returns true if a document is opened

Implements MWAWListener.

## § isHeaderFooterOpened()

bool MWAWGraphicListener::isHeaderFooterOpened | ( |  | ) | const
| virtual

returns true if the header/footer is open

Implements MWAWListener.

## § isPageSpanOpened()

bool MWAWGraphicListener::isPageSpanOpened | ( |  | ) | const
| virtual

returns true if a page is opened

Implements MWAWListener.

## § isParagraphOpened()

bool MWAWGraphicListener::isParagraphOpened | ( |  | ) | const
| virtual

returns true if a paragraph or a list is opened

Implements MWAWListener.

## § isSectionOpened()

bool MWAWGraphicListener::isSectionOpened | ( |  | ) | const
| inlinevirtual

returns true if a section is opened

Implements MWAWListener.

## § isSubDocumentOpened()

bool MWAWGraphicListener::isSubDocumentOpened | ( | libmwaw::SubDocumentType & | subdocType | ) | const
| virtual

returns try if a subdocument is open

Implements MWAWListener.

## § openFrame()

bool MWAWGraphicListener::openFrame | ( | MWAWPosition const & | pos,
|  | MWAWGraphicStyle const & | style = `MWAWGraphicStyle::emptyStyle()`
| ) |  |
| virtual

store the position and the style (which will be needed further to insert a textbox or a table with openTable)

Implements MWAWListener.

Referenced by insertFooter(), insertHeader(), insertTable(), and insertTextBox().

## § openGroup()

bool MWAWGraphicListener::openGroup | ( | MWAWPosition const & | pos | ) |
| virtual

open a group

Implements MWAWListener.

## § openLayer()

bool MWAWGraphicListener::openLayer | ( | librevenge::RVNGString const & | name | ) |

open a layer

## § openLink()

void MWAWGraphicListener::openLink | ( | MWAWLink const & | link | ) |
| virtual

open a link

Implements MWAWListener.

## § openMasterPage()

bool MWAWGraphicListener::openMasterPage | ( | MWAWPageSpan & | masterPage | ) |

opens a master page

## § openSection()

bool MWAWGraphicListener::openSection | ( | MWAWSection const & | section | ) |
| virtual

open a section if possible

Implements MWAWListener.

## § openTable() [1/2]

void MWAWGraphicListener::openTable | ( | MWAWTable const & | table | ) |
| virtual

open a table (using the last parameters of openFrame for the position )

Implements MWAWListener.

## § openTable() [2/2]

void MWAWGraphicListener::openTable | ( | MWAWPosition const & | pos,
|  | MWAWTable const & | table,
|  | MWAWGraphicStyle const & | style
| ) |  |

open a table in a given position

## § openTableCell()

void MWAWGraphicListener::openTableCell | ( | MWAWCell const & | cell | ) |
| virtual

open a cell

Implements MWAWListener.

## § openTableRow()

void MWAWGraphicListener::openTableRow | ( | float | h,
|  | librevenge::RVNGUnit | unit,
|  | bool | headerRow = `false`
| ) |  |
| virtual

open a row with given height ( if h < 0.0, set min-row-height = -h )

Implements MWAWListener.

## § operator=()

MWAWGraphicListener& MWAWGraphicListener::operator= | ( | const MWAWGraphicListener & |  | ) |
| private

## § setDocumentLanguage()

void MWAWGraphicListener::setDocumentLanguage | ( | std::string const & | locale | ) |
| virtual

sets the documents language

Implements MWAWListener.

## § setDocumentMetaData()

void MWAWGraphicListener::setDocumentMetaData | ( | librevenge::RVNGPropertyList const & | metadata | ) |
| virtual

sets the documents metadata

Implements MWAWListener.

## § setFont()

void MWAWGraphicListener::setFont | ( | MWAWFont const & | font | ) |
| virtual

sets the font

Implements MWAWListener.

## § setParagraph()

void MWAWGraphicListener::setParagraph | ( | MWAWParagraph const & | paragraph | ) |
| virtual

sets the paragraph

Implements MWAWListener.

## § startDocument()

void MWAWGraphicListener::startDocument | ( |  | ) |
| virtual

starts a new document

Implements MWAWListener.

Referenced by _openPageSpan(), MWAWTextListener::insertShape(), openMasterPage(), MsWksGraph::send(), HanMacWrdKGraph::sendEmptyPicture(), HanMacWrdJGraph::sendEmptyPicture(), HanMacWrdKGraph::sendFrame(), HanMacWrdJGraph::sendFrame(), ClarisWksGraph::sendGroupChild(), and MarinerWrtGraph::sendRule().

## Member Data Documentation

## § m_documentInterface

librevenge::RVNGDrawingInterface* MWAWGraphicListener::m_documentInterface
| protected

the document interface

Referenced by _changeList(), _closeListElement(), _closePageSpan(), _closeParagraph(), _closeSpan(), _flushText(), _handleFrameParameters(), _openListElement(), _openPageSpan(), _openParagraph(), _openSpan(), addEmptyTableCell(), closeGroup(), closeLayer(), closeLink(), closeTable(), closeTableCell(), closeTableRow(), endDocument(), insertEOL(), insertField(), insertFooter(), insertHeader(), insertPicture(), insertShape(), insertTab(), insertTextBox(), openGroup(), openLayer(), openLink(), openMasterPage(), openTable(), openTableCell(), openTableRow(), and startDocument().

## § m_ds

shared_ptr<MWAWGraphicListenerInternal::GraphicState> MWAWGraphicListener::m_ds
| protected

the actual global state

Referenced by _changeList(), _closePageSpan(), _endSubDocument(), _handleFrameParameters(), _openPageSpan(), _startSubDocument(), canWriteText(), endDocument(), getPageSpan(), getSection(), handleSubDocument(), insertBreak(), insertFooter(), insertGroup(), insertHeader(), insertPicture(), insertShape(), insertTable(), insertTextBox(), isDocumentStarted(), isHeaderFooterOpened(), isPageSpanOpened(), isSubDocumentOpened(), MWAWGraphicListener(), openFrame(), openGroup(), openLayer(), openMasterPage(), setDocumentLanguage(), setDocumentMetaData(), and startDocument().

## § m_parserState

MWAWParserState& MWAWGraphicListener::m_parserState
| protected

the parser state

Referenced by _changeList(), _getListId(), _openSpan(), insertCharacter(), and openTableCell().

## § m_ps

shared_ptr<MWAWGraphicListenerInternal::State> MWAWGraphicListener::m_ps
| protected

the actual local parse state

Referenced by _changeList(), _closeListElement(), _closePageSpan(), _closeParagraph(), _closeSpan(), _endSubDocument(), _flushText(), _getListId(), _handleFrameParameters(), _openListElement(), _openPageSpan(), _openParagraph(), _openSpan(), _popParsingState(), _pushParsingState(), _resetParagraphState(), _startSubDocument(), addEmptyTableCell(), canWriteText(), closeFrame(), closeGroup(), closeLayer(), closeLink(), closeTable(), closeTableCell(), closeTableRow(), getFont(), getParagraph(), handleSubDocument(), insertBreak(), insertChar(), insertCharacter(), insertComment(), insertEOL(), insertField(), insertGroup(), insertNote(), insertPicture(), insertShape(), insertTab(), insertTable(), insertTextBox(), insertUnicode(), insertUnicodeString(), isParagraphOpened(), isSubDocumentOpened(), MWAWGraphicListener(), openFrame(), openGroup(), openLayer(), openLink(), openTable(), openTableCell(), openTableRow(), setFont(), and setParagraph().

## § m_psStack

std::vector<shared_ptr<MWAWGraphicListenerInternal::State> > MWAWGraphicListener::m_psStack
| protected

stack of local state

Referenced by _popParsingState(), and _pushParsingState().

The documentation for this class was generated from the following files:

- MWAWGraphicListener.hxx
- MWAWGraphicListener.cxx